<?php

GUIFactory::setMainGUI("main");

mysession_var_reg("BUNDLE_IMPORT_ID");

$mainGUI = &GUIFactory::getMainGUI();
$mainGUI->includeJS( "hiselector" );

node_class("htmlformwizard");
node_class("itemlist3");
node_class("itemlistcomponent");
node_class("resultsetformatter");




ItemList3::registerMainGUIDependencies();


define("CONFLICT_IGNORE", 1);
define("CONFLICT_OVERWRITE", 2);
define("CONFLICT_COPY", 3);
define("CONFLICT_ABORT", 4);

if ($bundleimportid) {
 $BUNDLE_IMPORT_ID = $bundleimportid;
}

function rerunDryrun(&$form, $param) {
 global $BUNDLE_IMPORT_ID, $REDO;

 
 $folderselect = &$form->resolveComponent( 'conflicts.folderselect' );
 if ($folderselect && !is_a($folderselect, "nodeexception")) {
 $folder = $folderselect->getResultObject();
 $folder_id = $folder->getID();
 } else {
 $folder_id = false;
 }

 
 $bundleimport = &NodeFactory::getStaticInstanceOf(T_BUNDLE_IMPORT, $BUNDLE_IMPORT_ID);
 $bundleimport->startImportDryrun($folder_id);
 $REDO = 1010;
}

class BehaviourFormatter extends ResultsetFormatter {
 function format( $row ) {
 global $ICO_CONFLICT_IGNORE, $ICO_CONFLICT_COPY, $ICO_CONFLICT_REPLACE, $ICO_CONFLICT_DEFAULT;
 switch ($row["conflictbehaviour"]) {
 case CONFLICT_IGNORE:
 $icon = $ICO_CONFLICT_IGNORE;
 $alt = i18n('Ignorieren (Lokale Version bleibt bestehen)');
 break;
 case CONFLICT_COPY:
 $icon = $ICO_CONFLICT_COPY;
 $alt = i18n('Neu Anlegen (Lokale Version bleibt bestehen, Version aus Bundle wird als neues Objekt angelegt.)');
 break;
 case CONFLICT_OVERWRITE:
 $icon = $ICO_CONFLICT_REPLACE;
 $alt = i18n('Ersetzen (Version aus Bundle ueberschreibt lokale Version)');
 break;
 default:
 $icon = $ICO_CONFLICT_DEFAULT;
 $alt = i18n('default');
 break;
 }
 return "<img style=\"margin-left: 42%\" src=\"$icon\" alt=\"$alt\" title=\"$alt\"/>";
 }
}

class ActionFormatter extends ResultsetFormatter {
 var $action_i18n = array();

 function ActionFormatter() {
 $this->action_i18n["created"] = i18n("Creating");
 $this->action_i18n["ignored"] = i18n("Ignoring");
 $this->action_i18n["copy"] = i18n("Copying");
 $this->action_i18n["replaced"] = i18n("Replacing");
 $this->action_i18n["deleted"] = i18n("Deleting");
 }

 function format ( $row ) {
 return $this->action_i18n[$row["action"]];
 }
}

class ConflictAssFormatter extends ResultsetFormatter {
 function format ($row ) {
 $assistent = "ID: " . $row["localid"] . "<br/>";
 $assistent .= i18n("Global ID").": " . $row["globalprefix"] . "." . $row["globalid"] . "<br/>";
 switch ($row["ttype"]) {
 case T_PAGE:
 case T_IMAGE:
 case CT_FILE:
 case T_FOLDER:
 
 if ($row["folderpath"]) {
 $assistent .= i18n("Folder").":<br/>" . $row["folderpath"] . "<br/>";
 }
 break;
 }
 return $assistent;
 }
}

class ConflictReasonFormatter extends ResultsetFormatter {
 function format( $row ) {
 if ($row["recoverable"] ) {
 return $row["conflictcause"];
 } else {
 return "<span style=\"color:red\">".$row["conflictcause"]."</span>";
 }
 }
}

class ConflictBehaviourAction extends GenericAction {
 var $d_commandName;
 var $conflictBehaviour;

 function ConflictBehaviourAction( $icon, $name, $description, $commandName) {
 parent::GenericAction( $icon, $name, $description );
 $this->d_commandName = $commandName;
 $this->conflictBehaviour = $this->getConflictBehaviour();
 }
 
 function getConflictBehaviour() {
 switch ($this->d_commandName) {
 case "ignore":
 return CONFLICT_IGNORE;
 break;
 case "copy":
 return CONFLICT_COPY;
 break;
 case "replace":
 return CONFLICT_OVERWRITE;
 break;
 default:
 return "NULL";
 break;
 }
 }
 
 function performAction( $idList, &$ds ) {
 
 query("UPDATE bundleimportconflict SET conflict_behaviour = " . sqlf_value($this->conflictBehaviour) . " WHERE id IN (" . implode(",", sqlf_tl_num_array($idList)) . ") AND reason != 'languagevariant'");
 while (list($k, $v) = each($ds->d_arr)) {
 if (in_array($v["id"], $idList)) {
 if ($ds->d_arr[$k]["reason"] != 'languagevariant') {
 $ds->d_arr[$k]["conflictbehaviour"] = $this->conflictBehaviour;
 }
 }
 }
 }
}

class ConflictBuilder extends WizardBuilder {

 function prepareStep(&$wizard, $stepNr, &$form) {
 global $BUNDLE_IMPORT_ID;
 if ( $stepNr == 1 ) {
 
 $bundleimport = &NodeFactory::getStaticInstanceOf(T_BUNDLE_IMPORT, $BUNDLE_IMPORT_ID);
 $conflicts = $bundleimport->getConflicts();
 if (count($conflicts) == 0) {
 $wizard->m_stepId = 2;
 $wizard->setButtonVisibility("back", false);
 }
 }
 }

 function fillStep(&$wizard, $stepNr, &$form) {
 if ($stepNr == 2) {
 
 $step1 = &$wizard->getStep(1);
 if ($step1) {
 $conflictComp = &$step1->resolveComponent( 'conflicts.conflictbehavior' );
 $conflict = $conflictComp->getSingleSelection();
 $bundleimportidComp = &$step1->resolveComponent( 'conflicts.bundleimportid' );
 $bundleimportid = $bundleimportidComp->getValue();
 } else {
 $conflict = "";
 global $bundleimportid;
 }
 $bundleimport = &NodeFactory::getStaticInstanceOf(T_BUNDLE_IMPORT, $bundleimportid);
 $summary = $bundleimport->getSummary($conflict == "ignore" ? CONFLICT_IGNORE : ($conflict == "copy" ? CONFLICT_COPY : ($conflict == "overwrite" ? CONFLICT_OVERWRITE : 0)));

 $dostr = "<ul>";
 foreach ($summary as $row) {
 
 
 $action = $row["action"];
 $isconflict = $row["isconflict"];
 if ($isconflict) {
 switch($row["conflict_behaviour"]) {
 case CONFLICT_IGNORE:
 $action = "ignored";
 break;
 case CONFLICT_COPY:
 $action = "copy";
 break;
 case CONFLICT_OVERWRITE:
 $action = "replaced";
 break;
 default:
 if ($conflict == "ignore") {
 $action = "ignored";
 }
 if ($conflict == "copy") {
 $action = "copy";
 }
 if ($conflict == "overwrite") {
 $action = "replaced";
 }
 break;
 }
 }
 $type = $row["type"];
 $count = $row["count"];
 $icon = $row["icon"];
 if ($action == "created") {
 $action = i18n("Creating");
 }
 if ($action == "ignored") {
 $action = i18n("Ignoring");
 }
 if ($action == "copy") {
 $action = i18n("Copying");
 }
 if ($action == "replaced") {
 $action = i18n("Replacing");
 }
 if ($action == "deleted") {
 $action = i18n("Deleting");
 }
 $dostr .= "<li><img src=\"$icon\" style=\"vertical-align:text-bottom;\"> $action $count x $type</li>";
 }
 $dostr .= "</ul>";
 $summaryComponent = &$form->getComponent( 'summary' );
 $summaryComponent->setText($dostr);
 $conflictComponent = &$form->getComponent( 'conflictbehavior' );
 $conflictComponent->setValue($conflict);
 $bundleimportidComponent = &$form->getComponent( 'bundleimportid' );
 $bundleimportidComponent->setValue($bundleimportid);
 }
 }

 function updateStep(&$wizard, $stepNr, &$form) {
 $this->fillStep($wizard, $stepNr, $form);
 }

 function createStep(&$wizard, $stepNr, &$form) {
 global $USER_ID, $ICO_CONFLICT_IGNORE, $ICO_CONFLICT_COPY, $ICO_CONFLICT_REPLACE, $ICO_CONFLICT_DEFAULT, $DB;
 if( $stepNr == 1 ) {
 
 global $bundleimportid, $bundleid;
 $bundleimport = &NodeFactory::getStaticInstanceOf(T_BUNDLE_IMPORT, $bundleimportid);
 $bundle = &NodeFactory::getStaticInstanceOf(T_BUNDLE, $bundleid);

 
 $importfolder_id = $bundle->getFieldValue('importfolder_id');

 
 $conflicts = $bundleimport->getConflicts();

 
 $unrecoverableConflicts = $bundleimport->hasUnrecoverableConflicts();

 
 $folderconflicts = $bundleimport->hasMissingFolderConflicts();

 node_class("labelcomponent");
 node_class("radiolistcomponent");
 $main = new ListComponent();
 $conflictdescription = new LabelComponent(null, i18n('importexport conflict description'), true);
 $main->setComponent('conflictdescription', $conflictdescription);

 $form->addButton( 'rerundryrun', new Button(i18n('Rerun dryrun')), new SimpleFormAction("rerunDryrun"), true);

 
 $editable = ( perm( $USER_ID, T_BUNDLE_IMPORT_ELEMENT, $bundleid, 1 ) || perm ($USER_ID, T_BUNDLE, '', 3) );

 
 if ($editable && !$unrecoverableConflicts) {
 $conflictbehavior = new RadioListComponent(i18n('Verhalten bei Objekten<br/>mit Konflikten'));
 $conflictbehavior->setOption("ignore", "<img style=\"margin-bottom: -3px\" src='$ICO_CONFLICT_IGNORE' /> " . i18n('Ignorieren (Lokale Version bleibt bestehen)'));
 $conflictbehavior->setOption("overwrite", "<img style=\"margin-bottom: -3px\" src='$ICO_CONFLICT_REPLACE' /> " . i18n('Ersetzen (Version aus Bundle ueberschreibt lokale Version)'));
 $conflictbehavior->setOption("copy", "<img style=\"margin-bottom: -3px\" src='$ICO_CONFLICT_COPY' /> " . i18n('Neu Anlegen (Lokale Version bleibt bestehen, Version aus Bundle wird als neues Objekt angelegt.)'));
 $main->setComponent("conflictbehavior", $conflictbehavior);
 }

 
 if ($folderconflicts || ($importfolder_id > 0 && $unrecoverableConflicts)) {
 node_class( "cnfolderobject" );
 node_class( "minibrowserhiselector" );
 node_class( "minibrowsersimpletree" );
 $wrapper = new MinibrowserSimpleTree( 1, T_CONTENT );
 $wrapper->setTType( T_FOLDER, new CNFolderObject() );
 $wrapper->setTType( T_NODE, new CNFolderNodeObject() );
 
 $minibrowser = new MinibrowserHiSelector($wrapper, i18n('Select target folder'), true);
 $minibrowserfc = &$minibrowser->getFormComponent();
 $minibrowserfc->setHelp(i18n('Select target folder for pages, files, images, folders and templates'));
 $minibrowser->setOptional(false);
 $main->setComponent('folderselect', $minibrowser);
 if ($importfolder_id > 0) {
 $importFolderObj = new CNFolderObject( $importfolder_id );
 $minibrowser->setObject( $importFolderObj );
 }
 
 
 if (!$editable) {
 $minibrowser->setEditable(false);
 }
 }
 
 
 if ($unrecoverableConflicts) {
 $unrecdescription = new LabelComponent(null, i18n('unrecoverable conflict description'), true);
 $main->setComponent('unrecconflictdescription', $unrecdescription);
 }
 
 
 if ($unrecoverableConflicts || $folderconflicts) {
 $wizard->setButtonVisibility("next", false);
 }

 
 $confl_pages = array();
 $confl_folders = array();
 $confl_files = array();
 $confl_images = array();

 
 foreach ($conflicts as $conflict) {
 if (!$conflict->getFieldValue("reason_obj_id")) {
 continue;
 }
 switch($conflict->getFieldValue("reason_obj_type")) {
 case T_PAGE:
 $confl_pages[] = $conflict->getFieldValue("reason_obj_id");
 break;
 case CT_FILE:
 $confl_files[] = $conflict->getFieldValue("reason_obj_id");
 break;
 case T_IMAGE:
 $confl_images[] = $conflict->getFieldValue("reason_obj_id");
 break;
 case T_FOLDER:
 $confl_folders[] = $conflict->getFieldValue("reason_obj_id");
 break;
 }
 }

 
 $confl_pages = get_folder_structure(T_PAGE, $confl_pages);
 $confl_folders = get_folder_structure(T_FOLDER, $confl_folders);
 $confl_files = get_folder_structure(CT_FILE, $confl_files);
 $confl_images = get_folder_structure(T_IMAGE, $confl_images);

 
 foreach ($conflicts as $conflict) {
 $url = "";
 $endurl = "";
 $url = $conflict->getDisplayURL();
 if ($url) {
 $url = "<a href=\"$url\">";
 $endurl = "</a>";
 }
 $action = $conflict->getAction();
 $importName = $conflict->getTypeInBundle() . ": " . $conflict->getNameInBundle();
 if ($action == "deleted") {
 $importName = "<span style=\"text-decoration:line-through\">" . $importName . "</span> (" . i18n("Deleted") . ")";
 }

 
 $path = null;
 switch($conflict->getFieldValue("reason_obj_type")) {
 case T_PAGE:
 $path = $confl_pages[$conflict->getFieldValue("reason_obj_id")];
 break;
 case CT_FILE:
 $path = $confl_files[$conflict->getFieldValue("reason_obj_id")];
 break;
 case T_IMAGE:
 $path = $confl_images[$conflict->getFieldValue("reason_obj_id")];
 break;
 case T_FOLDER:
 $path = $confl_folders[$conflict->getFieldValue("reason_obj_id")];
 break;
 }

 
 $data[] = array(
 "id" => $conflict->getId(), 
 "object" => $conflict->getTypeInSystem(),
 "importobject" => $conflict->getNameInBundle(),
 "localobject" => $url . $conflict->getNameInSystem() . $endurl,
 "conflictcause" => $conflict->getReason(),
 "conflictbehaviour" => $conflict->getFieldValue("conflict_behaviour"),
 "recoverable" => $conflict->getFieldValue("recoverable"),
 "reason" => $conflict->getFieldValue("reason"),
 "action" => $conflict->getFieldValue("action") ? $conflict->getFieldValue("action") : ($conflict->getFieldValue("reason_obj_id") ? "replaced" : "created"),
 "localid" => $conflict->getFieldValue("reason_obj_id"),
 "globalid" => $conflict->getFieldValue("globalid"),
 "globalprefix" => $conflict->getFieldValue("globalprefix"),
 "ttype" => $conflict->getFieldValue("obj_type"),
 "folderpath" => $path
 );
 }

 
 $ds = new ArrayDataSource($data,
 array (
 "object" => i18n("object"),
 "importobject" => i18n("Object In Bundle"),
 "localobject" => i18n("Conflicting Object In Local System"),
 "action" => i18n("Action"),
 "conflictcause" => i18n("conflict cause"),
 "conflictbehaviour" => i18n("conflict behaviour")
 )
 );

 
 if (!$unrecoverableConflicts) {
 $ds->addAction( new ConflictBehaviourAction( $ICO_CONFLICT_IGNORE, 'ignore', i18n('Ignorieren (Lokale Version bleibt bestehen)'), 'ignore' ) );
 $ds->addAction( new ConflictBehaviourAction( $ICO_CONFLICT_COPY, 'copy', i18n('Neu Anlegen (Lokale Version bleibt bestehen, Version aus Bundle wird als neues Objekt angelegt.)'), 'copy' ) );
 $ds->addAction( new ConflictBehaviourAction( $ICO_CONFLICT_REPLACE, 'replace', i18n('Ersetzen (Version aus Bundle ueberschreibt lokale Version)'), 'replace' ) );
 $ds->addAction( new ConflictBehaviourAction( $ICO_CONFLICT_DEFAULT, 'default', i18n( 'default'), null ) );
 }

 
 $ds->addFormatter( 'conflictbehaviour', new BehaviourFormatter() );
 $ds->addFormatter( 'conflictcause', new ConflictReasonFormatter() );
 $ds->addFormatter( 'action', new ActionFormatter() );

 
 $ds->addAssFormatter(new ConflictAssFormatter());

 
 $list = new ItemList3("conflict_list", $ds );
 $list->setGroupableColumns(array('object'));
 $list->setNextSortWay('object');

 $main->setComponent('list', new ItemListComponent( i18n('conflict behaviour'), $list ) );

 $bundleimportidComponent = new HiddenComponent( $bundleimportid );
 $main->setComponent("bundleimportid", $bundleimportidComponent);
 $form->addComponent("conflicts", $main);
 } else if( $stepNr == 2 ) {
 node_class("labelcomponent");
 node_class("hiddencomponent");
 $form->addComponent( 'lbl', new LabelComponent(null, '<b>'.i18n("Import Summary").'</b>', true) );
 $form->addComponent( 'summary', new LabelComponent(null, "", true) );
 $form->addComponent( 'conflictbehavior', new HiddenComponent("") );
 $form->addComponent( 'bundleimportid', new HiddenComponent("") );
 $form->addComponent( 'desc', new LabelComponent(null, i18n('import_warn_performance'), true));
 $wizard->lastStep();
 }
 $this->fillStep($wizard, $stepNr, $form);
 }

 function done( &$wizard ) {
 
 
 $step1 = &$wizard->getStep(1);
 $step2 = &$wizard->getStep(2);
 $conflictbehaviorComponent = &$step2->resolveComponent('conflictbehavior');
 $conflictbehavior = $conflictbehaviorComponent->getValue();

 
 $folder_id = false;
 if ($step1) {
 $folderselect = &$step1->resolveComponent( 'conflicts.folderselect' );
 if ($folderselect && !is_a($folderselect, "nodeexception")) {
 $folder = $folderselect->getResultObject();
 $folder_id = $folder->getID();
 }
 }

 $bundleimportidComponent = &$step2->resolveComponent('bundleimportid');
 $bundleimportid = $bundleimportidComponent->getValue();


 $bundleimport = &NodeFactory::getInstanceOf(T_BUNDLE_IMPORT, $bundleimportid);
 $bundleimport->startImport(false, $conflictbehavior, $folder_id);

 global $REDO, $type;
 $REDO = 1010;
 $type = "import";
 }

 function cancel( &$wizard ) {
 global $REDO, $type;
 $REDO = 1010;
 $type = "import";
 }
 function getDoneLabel() {
 return i18n( 'Start Import' );
 }
}

$form = new HtmlFormWizard("installwizard");
if ($form->isNew()) {
 $conflictBuilder = new ConflictBuilder();
 $form->setBuilder($conflictBuilder);
 $form->setHeader(i18n("Install Conflicts"));
}

$bundleimport = &NodeFactory::getStaticInstanceOf(T_BUNDLE_IMPORT, $BUNDLE_IMPORT_ID);
$bundlebuildid = $bundleimport->getBundleBuildId();
$bundlebuild = &NodeFactory::getStaticInstanceOf(T_BUNDLE_BUILD, $bundlebuildid);
$bundleid = $bundlebuild->getFieldValue("bundle_id");

load_menu(1012, T_BUNDLE_IMPORT_ELEMENT, $bundleid, "<span class=\"addInfo\">" . i18n("Install Conflicts") . "</span>");
?>
